/*
 * main.c
 * tictacpro
 *
 * Created by Carrington Vanston at KansasFest on 2015-07-23.
 * My first attempt at HackFest!
 *
 * RELEASED TO THE PUBLIC DOMAIN. You may reproduce, copy, edit, sample, publish, distribute, sell, make derived works,
 * and use/reuse/abuse any of the original material in this program in any way you wish.
 *
 * This was typed stream-of-consciousness in a few passes, making stuff up as I went. Please do not judge me by how sloppy,
 * inefficient, and inelegant this code is. I feel enough shame already. But at least it works (apparantly--it's highly untested).
 *
 * NO, I DO NOT WANT TO HEAR YOUR OPINION OF HOW I FORMAT THE BRACES.
 *
 * There are more comments than code down below. Dig in, have fun.
 */

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <peekpoke.h>
#include <limits.h>

char playerMove[3];
unsigned int activeGrid=0, playerMoveSquare, playerMoveGrid;
unsigned int currentPlayer=0;
unsigned int playerValue[2] = {100,1000};
unsigned int currentPlayerValue, opponentPlayerValue;
unsigned int playerTieValue=10000;
unsigned int gameStatus=0;	// 0 = in progress; 1= game ended in a win; 2 = game ended in a draw

                                /* Flags for debugging and testing, so test games are quicker:              */
unsigned int noSounds=0;		/* 1=run silent, run shallow                                                */
unsigned int noSpeedLimit=0;	/* 1=turn off delay in computer player moves and the "graphic flourishes"   */
unsigned int autoLoop=0;		/* 1=turn on auto repeat playing between 2 computer opponents               */

unsigned int playerScore[2] = {0,0};
char playerLetter[2] = {'X','O'};
char currentPlayerLetter;
char playerName[2][15] = {"",""};
unsigned int playerIsComputer[2] = {0,0};   //  0 = Human player, 1 = Computer Player
unsigned int playerPersonality[2][6] = { {0,0,0,0,0,0}, {0,0,0,0,0,0} };    // See description in setupComputerPlayer()

const int gridLocations[9][2] =
{
    // the top left corner of each grid on the "graphic" display
    {2,2},
    {10,2},
    {18,2},
    {2,10},
    {10,10},
    {18,10},
    {2,18},
    {10,18},
    {18,18}
};

const int gridOffsets[9][2] =
{
    // offset within each grid for each playable square
    {0,0},
    {2,0},
    {4,0},
    {0,2},
    {2,2},
    {4,2},
    {0,4},
    {2,4},
    {4,4}
};

const char *moveDecoder[18][9] =
{
    /*
    * Embarrassingly quick-and-dirty KFest coding. Such a kludge. Ugh. Look away!
    *
    * A smarter person than me (hi Martin) would have parsed the input to look for a letter and a number. But it was so
    * much faster to type this silly grid.
    *
    * I am become shame, destroyer of egos.
    */

    {"A1","A2","A3","B1","B2","B3","C1","C2","C3"},
    {"A4","A5","A6","B4","B5","B6","C4","C5","C6"},
    {"A7","A8","A9","B7","B8","B9","C7","C8","C9"},
    {"D1","D2","D3","E1","E2","E3","F1","F2","F3"},
    {"D4","D5","D6","E4","E5","E6","F4","F5","F6"},
    {"D7","D8","D9","E7","E8","E9","F7","F8","F9"},
    {"G1","G2","G3","H1","H2","H3","I1","I2","I3"},
    {"G4","G5","G6","H4","H5","H6","I4","I5","I6"},
    {"G7","G8","G9","H7","H8","H9","I7","I8","I9"},
    {"1A","2A","3A","1B","2B","3B","1C","2C","3C"}, // OK, I admit it. Here begins the EXACT SAME DATA AGAIN but with the pair-orders reversed.
    {"4A","5A","6A","4B","5B","6B","4C","5C","6C"}, // See, HackFest, THIS IS WHAT YOU GET when you fill the rest of KFest with
    {"7A","8A","9A","7B","8B","9B","7C","8C","9C"}, // such fun-to-do stuff. Instead of efficiency, you get ugly double-data sets.
    {"1D","2D","3D","1E","2E","3E","1F","2F","3F"}, // because I can cut-and-paste the pairs while paying attention to a session.
    {"4D","5D","6D","4E","5E","6E","4F","5F","6F"}, // I hope you think about what you've made me do. Now both of us should be ashamed.
    {"7D","8D","9D","7E","8E","9E","7F","8F","9F"},
    {"1G","2G","3G","1H","2H","3H","1I","2I","3I"},
    {"4G","5G","6G","4H","5H","6H","4I","5I","6I"},
    {"7G","8G","9G","7H","8H","9H","7I","8I","9I"}
};

unsigned int thinkingDotPos = 0;
const char *thinkingDots[12] =
{
    {".     "},
    {"..    "},
    {"...   "},
    {"....  "},
    {"..... "},
    {"......"},
    {" ....."},
    {"  ...."},
    {"   ..."},
    {"    .."},
    {"     ."},
    {"      "}
};

unsigned int winningMoves[10][8][3] =
{
    /*
     * Winning moves organized into sets of 3 (e.g. top left, middle left, bottom left)
     * These "sets of 3" will be called "triples" -- a more useful word for variable names.
     * The list of triples themselves isn't ordered ... because I'm not sure yet what the heck
     * order that should be. HackFest is SO MUCH PRESSURE. Code fast! Faster! CODE LIKE THE WIND!
     *
     * Values are set as follows:
     *    1 to 9 = Available to play, with number matching the square within that grid
     *       100 = Taken by Player 0  (global variable playerValue[0])
     *      1000 = Taken by Player 1  (global variable playerValue[1])
     */
    { {1,3,2},{5,4,6},{7,9,8},{1,7,4},{5,2,8},{3,9,6},{5,1,9},{5,3,7} }, 	// This is Grid 0 (the overall play grid, comprised of 9 other grids)
    { {1,3,2},{5,4,6},{7,9,8},{1,7,4},{5,2,8},{3,9,6},{5,1,9},{5,3,7} }, 	// Grid 1 (top left)
    { {1,3,2},{5,4,6},{7,9,8},{1,7,4},{5,2,8},{3,9,6},{5,1,9},{5,3,7} }, 	// Grid 2 (top middle)
    { {1,3,2},{5,4,6},{7,9,8},{1,7,4},{5,2,8},{3,9,6},{5,1,9},{5,3,7} }, 	// etc. ...
    { {1,3,2},{5,4,6},{7,9,8},{1,7,4},{5,2,8},{3,9,6},{5,1,9},{5,3,7} },
    { {1,3,2},{5,4,6},{7,9,8},{1,7,4},{5,2,8},{3,9,6},{5,1,9},{5,3,7} },
    { {1,3,2},{5,4,6},{7,9,8},{1,7,4},{5,2,8},{3,9,6},{5,1,9},{5,3,7} },
    { {1,3,2},{5,4,6},{7,9,8},{1,7,4},{5,2,8},{3,9,6},{5,1,9},{5,3,7} },
    { {1,3,2},{5,4,6},{7,9,8},{1,7,4},{5,2,8},{3,9,6},{5,1,9},{5,3,7} },
    { {1,3,2},{5,4,6},{7,9,8},{1,7,4},{5,2,8},{3,9,6},{5,1,9},{5,3,7} } 	// Grid 9 (bottom right)
};

unsigned int gridStatus[10][10] =
{
    /*
     * gridStatus tracks the winner (if any) of each Grid, and also which Squares are still free to be played.
     *        0 = Available to play, with number matching the square within that grid (i.e. a digit 1 through 9)
     *      100 = Taken by Player 0  (global variable playerValue[0])
     *     1000 = Taken by Player 1  (global variable playerValue[1])
     *    10000 = Tied (only for grid winner tracking; global variable playerTieValue)
     * Note: each line is given TEN numbers, in this format:
     *				0,0,0,0,0,0,0,0,0,0
     *			   /   \_____________/
     *			  /           |
     *		Grid Winner       9 Squares within this Grid
     */

    {0,0,0,0,0,0,0,0,0,0}, 	// This is Grid 0 (the overall play grid, comprised of 9 other grids)
    {0,0,0,0,0,0,0,0,0,0}, 	// Grid 1 (top left)
    {0,0,0,0,0,0,0,0,0,0}, 	// Grid 2 (top middle)
    {0,0,0,0,0,0,0,0,0,0}, 	// etc. ...
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0} 	// Grid 9 (bottom right)

    /*
     * NOTE: At the moment, I'm not sure if I'm going to use gridStatus[0][1..0] to check for win/tie,
     * or use gridStatus[1..9][0].  There isn't any sense in actually including both, because
     * they're going to contain THE SAME DATA. Yes, inefficiency is my watchword. But loops etc. might be more
     * convenient if the grid/square numbers are 1..9 rather than 0..8, if only because I can use the empty value
     * to indicate a given positoin is available ... or, wait, unavailable? ... maybe??? Haven't really thought this
     * through, which probably means I'm going to mix and match below which will lead to all sorts
     * of problems. Oh well, it's KansasFest, so no time for thought Dr. Jones.
     */
};

void waitForReturn()
{
    char c;
    while(1)
    {
        if (kbhit())
        {
            c = cgetc();
            if (c == '\r')  // It is \r, not \n, right?? I guess I'm about to find out.
            {
                break;
            }
        }
    }
    return;
}

unsigned int hasReturnBeenPressed()
{
    char c;

    if (noSpeedLimit) return 1;		/* DEBUGGING  If noSpeedLimit==1, then just return instantly
                                       because it must be a computer-vs-computer speed run/test   */
    if (kbhit())
    {
        c = cgetc();
        if (c == '\r')
        {
            return 1;
        }
    }
    return 0;
}

void clearKeyBuffer()
{
    char c;
    
    while (kbhit()) { c = cgetc(); }
}

void waitForDuration(unsigned int timeLimit)
{
    unsigned int counter;
    for (counter=0; counter < timeLimit; ++counter) // "time" is being used here in a very loose sense
    {
        // Is this really the best way to do this? Hmmm. Probably not. [shrug]
    }
    return;
}

void centre(unsigned int xPos, unsigned int yPos, char text[])      // YES IT IS SPELLED CORRECTLY.
{
    unsigned int offset = (strlen(text)/2) + (strlen(text) % 2);
    
    cputsxy( xPos-offset, yPos, text);
}

void feedback(char text[])
{
    unsigned int yPos;
    
    yPos = 8 + (10*(currentPlayer));
    centre(32,yPos,"              ");
    centre(32,yPos,text);
}

void decodePlayerMove()
{
    /*
     * Takes playerMove (already set to a 2-char uppercase string, such as "A5" or "5A")
     * and sets playerMoveSquare and playerMoveGrid to the corresponding integers.
     *
     * e.g. playerMove="F6" would result in playerMoveGrid=5 and playerMoveSquare=9
     */

    unsigned int thisGrid, thisSquare;
    
    playerMoveSquare = 0;
    playerMoveGrid = 0;
    
    for (thisGrid=0; thisGrid < 18; ++thisGrid)
    {
        for (thisSquare=0; thisSquare < 9; ++thisSquare)
        {
            if (!strncmp(playerMove,moveDecoder[thisGrid][thisSquare],2))
            {
                playerMoveSquare = thisSquare+1;
                playerMoveGrid = thisGrid+1;
                break;
            }
        }
        if (playerMoveSquare>0) break;
    }
    if (playerMoveGrid>9) playerMoveGrid=playerMoveGrid-9;
    if ((!playerMoveSquare>0) || (!playerMoveGrid>0)) { playerMoveGrid=0; playerMoveSquare=0; }
}

void beepSetup() {
    /* 
     * This and beep() below are essentially copied straight out of the Red Book. Why?
     * Because I could not figure out any way at all to natively make any @#$%&* sound from within C.
     * Sheesh, Hackfest for the lose. I shoulda done this in BASIC.
     *
     * I'm really only including sound at all because I was SHAMED INTO IT by watching
     * Michael Mahon's fantastic music session. How could I make a silent game after that?
     *
     * Additional credit: I found out about the Red Book's routine by first finding the code
     * mentioned and discussed on the Eight Bit Sound And Fury site:
     * http://eightbitsoundandfury.ld8.org/programming.html
     * Then when I Googled the code from there, that lead me back to the Red Book original.
     * It always comes back to the Red Book eventually, doesn't it?
     */
    
    unsigned int i, address;
    unsigned int data[21]={173,48,192,136,208,5,206,1,3,240,9,202,208,245,174,0,3,76,2,3,96};
    
    address=770;	/* Start at 0x0302, although the routine does use 768 and 769 (0x0300 and 0x0301)
                     * as well, but they are called independently by the beep() routine below
                     * and used to store the bytes to set pitch and duration
                     *
                     * Setting this routing to begin at 0x0300 because I *think* 0x0300 through 0x03CF
                     * is free memory available for my use. Right? Right?!?
                     *
                     * I unfolded the memory map, and now I can't get it refolded.
                     */
    
    for (i=0; i<22; ++i)
    {
        POKE(address,data[i]);
        ++address;
    }
    
    // New record for highest comment-to-code ratio so far. Go Team Blather.
}

void beep(unsigned int pitch, unsigned int duration)
{
    /*
     * Credit: The actual beeping routine is in beepSetup() above, and was taken from the Red Book. (See comment in beepSetup.)
     * Did I say "taken"? More like "copied exactly by a guy who barely knows what he is doing".
     */
    
    if (noSounds) return;	/* DEBUGGING run silent, run shallow */
    
    POKE(768,pitch);
    POKE(769,duration);
    __asm__ ("JSR $0302");
    
    /*	The following came from a few online lists that disagreed, so I charted them and "smoothed out" the values.
     *  I CAN SEE THE MUSIC!
     *  Note    Octave 0	Octave 1	Octave 2	Octave 3	Octave 4
     *	C       255         128         64          32          16
     *	C#      240         120         60          30          15
     *	D       228         114         57          28          14
     *	D#      216         108         54          27          13
     *	E       204         102         51          25          12
     *	F       192         96          48          24          12
     *	F#      180         90          45          22          11
     *	G       170         86          43          21          10
     *	G#      160         80          40          20          10
     *	A       152         76          38          19          9
     *	A#      144         72          36          18          9
     *	B       136         68          34          17          8
     */
}

void playSoundError()
{
    beep(127,63);
    beep(159,63);
}

void playSong(unsigned int i)
{
    /*
     * OK, let's face it: "song" is being used in a very loose way here
     */
    
    switch (i)
    {
        case 0:				/* Player 0 takes a grid        */
            beep(128, 64);
            beep( 86, 64);
            beep(102, 64);
            beep(114,128);
            beep(128,192);
            break;
        case 1:				/* Player 1 takes a grid        */
            beep( 96, 64);
            beep( 96, 64);
            beep(102, 64);
            beep( 57,128);
            beep( 65,192);
            break;
        case 2:				/* A grid is tied               */
            beep(114, 64);
            beep(102, 64);
            beep( 96,128);
            beep( 86, 64);
            beep(102,192);
            break;
        case 3:				/* Player 0 wins the game       */
            beep(128, 64);
            beep( 86, 64);
            beep(102, 64);
            beep(114,128);
            beep(128,192);
            break;
        case 4:				/* Player 1 wins the game       */
            beep( 96, 64);
            beep( 96, 64);
            beep(102, 64);
            beep( 57,128);
            beep( 65,192);
            break;
        case 5:				/* The game ends in a tie       */
            beep(114, 64);
            beep(102, 64);
            beep( 96,128);
            beep( 86, 64);
            beep(102,192);
            break;
        case 6:				/* Splash screen intro music    */
        default:
            beep(114, 64);
            beep(102, 64);
            beep( 96,128);
            beep( 86, 64);
            beep(102,192);
    }
}

int checkMoveValidity()
{
    if ((!playerMoveSquare) || (!playerMoveGrid))
    {
        playSoundError();
        feedback("INVALID MOVE");
        return 0;
    }
    if ((activeGrid) && (playerMoveGrid != activeGrid))
    {
        playSoundError();
        feedback("WRONG GRID");
        return 0;
    }
    if (gridStatus[playerMoveGrid][0]) 	// non-zero value means grid is already taken
    {
        playSoundError();
        feedback("GRID NOT EMPTY");
        return 0;
    }
    if (gridStatus[playerMoveGrid][playerMoveSquare]) 	// non-zero value means square is already taken
    {
        playSoundError();
        feedback("SQ. NOT EMPTY");
        return 0;
    }
    return 1;
}

unsigned int getText(unsigned int x, unsigned int y, char *text, unsigned int max)
{
    unsigned int i=0, done=0, length=0;
    char c;
    
    strcpy(text, "");
    gotoxy(x,y);
    
    while (!done)
    {
        c = toupper(cgetc());
        switch (c)
        {
            case 8:                 // case: delete/backspace/left
                if (i > 0)
                {
                    --i;
                    text[i] = '\0';
                    cputcxy(x+i,y,' ');
                    gotoxy(x+i,y);
                }
                break;
            case 27:                // case: escape
                cursor(0);
                i=0;
                strcpy(text, "");
                cclearxy(x,y,max);
                gotoxy(x,y);
                break;
            case 13:                // case: return
                done = 1;           // NB: text could still be empty.  strlen(text) is returned at end of function below
                break;
            default:
                if (i == max) continue;	// text is already at its max-letter limit.  max is all you get, greedy player!
                if (isprint(c))
                {
                    if (isalnum(c))	// looks like a check for "is aluminum" but that's probably not what it actually means. Probably.
                    {
                        text[i] = c;
                        cputc(c);
                        ++i;
                        break;
                    }
                }
        }
    }
    return strlen(text);
}

void getHumanPlayerMove()
{
    unsigned int xPos=25, yPos, max=2, lineLength=0;

    if (!currentPlayer) { yPos=5; } else { yPos=15; }
    strcpy(playerMove, "  ");
    cputsxy(xPos, yPos, "ENTER MOVE:   ");
    lineLength = getText(xPos+12, yPos, playerMove, max);
    cclearxy(xPos,yPos,14);
    feedback("");
    decodePlayerMove();     // Sets both playerMoveSquare and playerMoveGrid.  Will both be 0 if invalid move
    return;
}

void drawThinkingDots(unsigned int numDots)
{
    unsigned int xPos=33, yPos, counter, pauseTime=50;
    
    if (!currentPlayer) { yPos=5; } else { yPos=15; }
    
    for (counter=0; counter<numDots; ++counter)
    {
        cputsxy(xPos, yPos, thinkingDots[thinkingDotPos]);
        waitForDuration(pauseTime);
        ++thinkingDotPos;
        if (thinkingDotPos>11) thinkingDotPos=0;
    }
}

unsigned int getGridStrategicMultiplier(unsigned int whichGrid)
{
    /*
     * Returns a "strategic multiplier" based on how bad it would be for opponent to play in that Grid next.
     * I know it looks like I just came up with this idea here, but I'm actually back-tracking from typing
     * the getComputerPlayerMove() function below, where I actually worked out that I'll need this.
     * But let's pretent I knew it all along, ok? Oh yeah, look at me, Mr. Thinkahead.
     *
     * Ahem.
     *
     * Anyway, this returns strategicMultiplier for the given Grid, set as follows:
     *
     * 3 = fine
     * 2 = bad (opponent could win that Grid, but not the overall game)
     * 1 = very bad (Grid already won, so opponent would actually get to play anywhere she wants)
     * 0 = terrible (opponent could win the whole shebang. Yes, the entirety of the shebang.)
     */
    
    signed int tripleState;
    unsigned int thisTriple, strategicMultiplier=3;
    
    /* First, let's check to see if the given Grid (whichGrid) was already won/tied.
     * That's the easiest to check. Also, if it's already won/tied, then it follows
     * that it can't be used to win the whole game (otherwise it already would have).
     */
    if (gridStatus[0][whichGrid])	// This Grid was already won or tied, so Squares that would send opponent here are bad
    {
        /* I could just do a "return 1" to save cycles etc. But I'm going to set the strategicMultiplier
         * and then return it, just as a reminder because I KEEP COMING BACK HERE to edit the possible values for
         * the multiplier (they were originally just 1..2, then later 0..2, then 1..3, now 0..3). Setting the variable makes
         * it less likely I'll miss this instance (*again*) when I no doubt once again change it later.
         */
        strategicMultiplier=1;
        return strategicMultiplier;
    }
    
    /* 
     * Next, let's check to see if opponent could win the Grid on her next move.
     */
    for (thisTriple=0; thisTriple<8; ++thisTriple)
    {
        drawThinkingDots(1);
        tripleState = winningMoves[whichGrid][thisTriple][0] + winningMoves[whichGrid][thisTriple][1] + winningMoves[whichGrid][thisTriple][2];
        /*
         * If a winningMoves[] triple for a given grid has 2 x opponentPlayerValue and 1 x {1..9}
         * then it is winnable by opponent on her next move (and also therefore is an available blocking move for us)
         */
        if ( (tripleState > (opponentPlayerValue*2)) && (tripleState < (opponentPlayerValue*2)+10) )
        {
            strategicMultiplier=2;
            break;  // Drop out of loop now that we found the badness.
        }
    }
    
    if (strategicMultiplier==3) return strategicMultiplier; // If opponent can't win the Grid, then it follows she can't win the game
    

    /* 
     * If we get here, opponent can win the Grid. So let's check if doing so would win the overall game.
     * The way to check this is to see if any of the triples are currently in a state where
     * they have 2 x opponentPlayerValue plus 1 remaining free one that is this Grid. I think.
     */
    for (thisTriple=0; thisTriple<8; ++thisTriple)
    {
        drawThinkingDots(1);
        tripleState = winningMoves[0][thisTriple][0] + winningMoves[0][thisTriple][1] + winningMoves[0][thisTriple][2];
        /*
         * If a winningMoves[] triple for a given grid has 2 x opponentPlayerValue and 1 x {1..9}
         * then it is winnable by opponent on her next move (and also therefore is an available blocking move for us)
         */
        if (tripleState-(opponentPlayerValue*2) == whichGrid)
        {
            /*
             * Yikes! Opponent can beat us if they get to play next in this Grid.
             * Again, I'm doing this in a set-then-return wasteful way, but it'll help me spot
             * the variable instance when I inevitably come back and change it for the 4th time.
             */
            strategicMultiplier=0;
            return strategicMultiplier;
        }
    }
    
    return strategicMultiplier; // Should still be its original value (i.e. 3) if we get to here. Right?
}

unsigned int checkForGameWinningMove(unsigned int whichGrid)
{
    // Returns 1 if local win in whichGrid would win the whole game (else, returns 0)
    
    signed int tripleState;
    unsigned int thisTriple;
    
    for (thisTriple=0; thisTriple<8; ++thisTriple)
    {
        drawThinkingDots(1);
        tripleState = winningMoves[0][thisTriple][0] + winningMoves[0][thisTriple][1] + winningMoves[0][thisTriple][2];
        if (tripleState-(currentPlayerValue*2) == whichGrid) return 1;
    }
    return 0;
}

void getComputerPlayerMove()
{
    unsigned int bestMoveValue=0, bestMoveGrid=0, bestMoveSquare=0, thisMoveValue=0;
    unsigned int myDestinationCount[10] = {0,0,0,0,0,0,0,0,0,0};        // Really just need 9 values to match qty of Grids, but I think making these arrays use
    unsigned int opponentDestinationCount[10] = {0,0,0,0,0,0,0,0,0,0};  // 0..9 will make loops nicer since I won't have to do a [thisGrid-1] calc each time.
    unsigned int xPos=25, yPos;
    unsigned int possibleMoveCount=0, exchange;
    unsigned int thisSquare, thisGrid, thisTriple, tripleState, thisTripleElement;
    unsigned int gridToBlock=0, squareToBlock=0, gridLoopStart, gridLoopEnd, wholeShebang=0;
    unsigned int foo;   // I bet I'll need a foo when I'm coding this quickly. Let's see if/how I end up using it below.
    
    /* Okay, let's brainstorm a bit. How to decide which Grid to send the opponenet to next?
     * Perhaps use a "multiplier" to raise the value of the individual Square's local benefits?
     * That is, a block move is good locally, but a block move that will send the opponent to
     * a crappy Grid is better than a block move that will send them to a good (for them) one,
     * right? I think so. And perhaps it's better to NOT take a local block if it would mean
     * the opponent would go to an already-taken Grid and get to play anywhere next move?
     *
     * So: the base value of a given Square is multiplied by a "strategic multiplier"
     * to determine actual overall strategic value. Like a ranting of 0..2?
     * (i.e. 2=okey-dokey, 1=not great, 0=will cause me to lose).
     *
     * [Edit: Yes, I'm now inserting comments within comments. I'm typing this after having
     * gone back up and made a getGridStrategicMultiplier() function. I ended up
     * making the range 0..3 instead, still ranked higher=better. We now return you
     * to your regularly schedule rambling comments.]
     *
     * [Also: lunch today was good. I dig the new cafe here at Rockhurst.]
     *
     * I wonder if there's a benefit to giving a higher multiple to Grids that are *good* for me? I think not,
     * since I can only force opponents to play in a given Grid, not force them to let me play there. I'll think about it.
     *
     * Let's think about values. Like, 20 points for a move that wins a Grid, and 15 points for a move that blocks an opponnent 
     * from winning a Grid? So, then if the win move would send opponent to a 1-multiplier Grid, but the block move would send
     * opponent to a 2-multiplier Grid, then the block move would be taken instead (i.e. 20x1 is less than 15x2). But is that 
     * actually the move we'd prefer? Not sure yet.
     *
     * Hmmm, maybe I can just give each computer player a "personality" which is just a set of different values for these things? 
     * Then let them play each other and see which values win the most?
     *
     * [Edit: yes, I went with the personality idea. That's now implemented.]
     *
     * To give a little more "fine tuning" I'm also going to throw in a strategicAddition which will, um, okay I'm not quite sure yet. 
     * I haven't actually planned out stuff in advance. But maybe some player "personalities" could use it to raise or lower
     * the value of Grids a bit more or less than other players would?
     *
     * I dunno. Don't ask me, I just type here.
     *
     * Okay, that's enough of a break (which is really what typing all this was). Less thinky-thinky, more typey-typey.
     */
    
    unsigned int strategicMultiplier[10] = {2,2,2,2,2,2,2,2,2,2};       // As above, array has 10 elements just to make looping gentle like a bunny
    unsigned int strategicAddition[10] = {0,0,0,0,0,0,0,0,0,0};         // Again, 10 values because of bunnies. Or laziness.
    unsigned int baseSquareValue[10] = {10,10,10,10,10,10,10,10,10,10}; // Fine, whatever. It's easier this way. Don't judge me. YOU DON'T KNOW MY LIFE.
    char buffer[20];
    
    if (!currentPlayer) { yPos=5; } else { yPos=15; }   // Set row for printing feedback lines
    
    strcpy(playerMove, "  ");
    cputsxy(xPos, yPos, "THINKING");
    playerMoveGrid = activeGrid;	// NB: could be 0 if game is in a "go anywhere" state
    playerMoveSquare = 0;
    thinkingDotPos=0;
    drawThinkingDots(3);
    
    /* 
     * First loop through Grids, and get their strategicMultiplier values.
     *
     * Also, the more Squres an opponent already has in a given Grid, the worse it is to let them have another.
     * Right? Maybe? Anyway, let's slightly decrease the value for each Square they've already taken.
     * That way, all other things being equal we'll send them to a Grid with fewer benefits for their next move.
     * And since we're looping through all the Grids and Squares anyway, let's count up the free squares while we go
     * and keep track of the number of remaining moves (in possibleMoveCount). Will that be useful? I dunno yet.
     */
    for (thisGrid=1; thisGrid<10; ++thisGrid)
    {
        drawThinkingDots(1);
        strategicMultiplier[thisGrid] = getGridStrategicMultiplier(thisGrid);
        
        for (thisSquare=1; thisSquare<10; ++thisSquare)
        {
            if (gridStatus[thisGrid][thisSquare]==opponentPlayerValue) --baseSquareValue[thisGrid]; // Decrease value based on # Squares opponent has already taken
            if (gridStatus[thisGrid][thisSquare] < 10)
            {
                if ( (!activeGrid) || (thisGrid==activeGrid) ) ++possibleMoveCount; // Let's keep track of the total remaining available moves
            }

        }
        
    }
    
    /* Now let's loop through the *available* Grids and Squares and calculate an overall strategic value to decide which move to actually take.
     *
     * Giving it some thought (which, let's face it, is about the first time I've paused to do that so far in my mad rush to get this done quickly) 
     * I can foresee an issue with potentially assigning double value to a Square that is part of a triple where each player has taken 1 Square (e.g. -XO).
     * That is, if you are X then it is valuable to complete a triple like XX_ for a win, and it's valuable to block a triple like OO_, but there is 
     * no real value in finishing a triple like OX_.
     *
     * I'm going to avoid the problem by considering triples with a single Square taken (e.g. X--) separately from triples with two matching Squares 
     * taken (e.g. XX-), rather than just assigning a value based on the number of Squares you or the opponent has taken in a given triple. I bet there's a
     * much more elegant way to do this, but it's late afternoon already so I just gotta code code code. More caffeine will solve all my problems.
     */
    
    if (activeGrid)
    {
        gridLoopStart=activeGrid;
        gridLoopEnd=activeGrid+1;
    }
    else
    {
        gridLoopStart=1;
        gridLoopEnd=10;
    }

    bestMoveValue=0;
    
    for (thisGrid=gridLoopStart; thisGrid<gridLoopEnd; ++thisGrid)  // Loop through the activeGrid (or all Grids if there's no active one).
    {
        for (thisSquare=1; thisSquare<10; ++thisSquare)
        {
            if (gridStatus[thisGrid][0]) continue;          // This Grid was already won or tied
            if (gridStatus[thisGrid][thisSquare]) continue;	// This Square was already taken
            
            drawThinkingDots(1);
            thisMoveValue=0;
            
            if (thisSquare != thisGrid)
            {
                thisMoveValue+=playerPersonality[currentPlayer][0];   // Value of sending opponent to another Grid rather than staying here, all other things being equal.
            }
            
            for (thisTriple=0; thisTriple<8; ++thisTriple)
            {
                tripleState = winningMoves[thisGrid][thisTriple][0] + winningMoves[thisGrid][thisTriple][1] + winningMoves[thisGrid][thisTriple][2];
                
                for (foo=0; foo<3; ++foo)   // Yep, told you so. Always a foo when I'm rushing.
                {
                    thisTripleElement = winningMoves[thisGrid][thisTriple][foo];
                    if (thisTripleElement!=thisSquare) continue;    // thisTripleElement is either another Square or already taken
                    
                    if ( (tripleState > (currentPlayerValue)) && (tripleState < (currentPlayerValue + 20)) )  // Player has 1 unopposed Square in this triple
                    {
                        thisMoveValue+=playerPersonality[currentPlayer][1];   // Value of a taking a second Square in a local triple (e.g. turning X-- into XX-)
                    }
                    
                    if ( (tripleState > (opponentPlayerValue)) && (tripleState < (opponentPlayerValue + 20)) )  // Opponent has 1 unopposed Square in this triple
                    {
                        thisMoveValue+=playerPersonality[currentPlayer][2];   // Value of a making a pre-emptive block in a local triple (e.g. turning O-- into OX-)
                    }

                    if ( (tripleState > (currentPlayerValue*2)) && ((tripleState-(currentPlayerValue*2) < 10)) )    // Player could win local Grid with this move
                    {
                        thisMoveValue+=playerPersonality[currentPlayer][3];   // Value of a local win move
                        wholeShebang = checkForGameWinningMove(thisGrid);
                        if (wholeShebang)
                        {
                            thisMoveValue+=playerPersonality[currentPlayer][5];   // Value of winning the whole game
                        }
                        
                        // TO DO:   If this win is in the same Square as the Grid number, then this is the same
                        //          as sending next move to *any* Grid, so we should ... change the applicable strategicMultiplier?
                        //          But is that possible to do for this single move? Or do we NEED MORE FOO ??? (Can't have enough foo!)
                        //          Whatever. I'll add it later. [If this comment is still here, then whoops I didn't get around to it.)
                    }
 
                    if ( (tripleState > (opponentPlayerValue*2)) && ((tripleState-(opponentPlayerValue*2) < 10)) )  // Opponent could win local Grid with this move
                    {
                        thisMoveValue+=playerPersonality[currentPlayer][4];   // Value of a local block move
                        
                        // TO DO:   If opponent wins this, would they win the whole game?
                        //          In that case, this block is very important unless we already found a local Grid win to take instead.
                        //          I should probably do something about that. But I keep getting distracted by KFest sessions. Oh well. Hackfest.
                    }

                }
                
            }   // End of looping through the Triples

            thisMoveValue+=baseSquareValue[thisSquare]; // baseSquareValue starts at 10 and goes down for each Square opponent has won in a Grid
            thisMoveValue*=strategicMultiplier[thisSquare];
            
            if ( thisMoveValue == bestMoveValue ) // To shake things up, occassionally swap to a move that's equally good. Hey, why not?
            {
                /* 
                 * I suspect the "correct" way to handle this would be to keep track of the potentially same-value moves until the end,
                 * and then randomly choose between all the tied-for-best options. But I'm tired and it's late, and I don't want to go
                 * to that effort. So I'm going to fudge it. That method has worked so far!
                 * 
                 * So here's a top-of-my-head idea, which hopefully is in the ballpark of good enough:
                 */
                drawThinkingDots(1);
                exchange = (rand() % ((possibleMoveCount+1)/2) );   // Chance to swap is relative to remaining free Squares
                if ( !exchange )
                {
                    bestMoveGrid = thisGrid;
                    bestMoveSquare = thisSquare;
                    bestMoveValue = thisMoveValue;
                }
                /* 
                 * I'm not really sure the above even makes any sense, either logically or mathematically. But right now I'm sitting in a
                 * KansasFest session and it's super hard to concentrate. Plus I think somebody is watching me type this and it's making me
                 * really self conscious. Hey person behind me, can you read this? Yes you, I'm typing to you. CAN YOU READ THIS?
                 *
                 * I guess not.
                 */
            }
            if ( (thisMoveValue > bestMoveValue) || (!bestMoveValue) )  // Check against !bestMoveValue is so we don't stall if the only moves are total loss moves
            {
                drawThinkingDots(1);
                bestMoveGrid = thisGrid;
                bestMoveSquare = thisSquare;
                bestMoveValue = thisMoveValue;
            }
            
        }
    }
    
    playerMoveGrid = bestMoveGrid;
    playerMoveSquare = bestMoveSquare;
    
    cclearxy(xPos, yPos, 14);
    feedback("");
    thinkingDotPos=0;	//  Just to reset it. Aesthetically it looks nicer if it begins a new dot series with each new move.
    
    return;
}

void drawMove(int gridCoordX, int gridCoodY, char c)
{
    int moveCoordX, moveCoordY, pauseTime=5000;
    
    moveCoordX = gridCoordX + gridOffsets[playerMoveSquare-1][0];
    moveCoordY = gridCoodY + gridOffsets[playerMoveSquare-1][1];
    
    POKE(50,127);  // Normal=255, Inverse=63, Flash=127
    cputcxy(moveCoordX,moveCoordY, c);
    
    if (!noSpeedLimit) waitForDuration(pauseTime);	// Delays long enough to display 3 (-ish) text flashes
    
    POKE(50,255);  // Normal=255, Inverse=63, Flash=127
    cputcxy(moveCoordX,moveCoordY, c);
}

int checkForWin(int whichGrid, int whichSquare)
{
    /*
     * Updates the winningMoves[][][] array to record the winner of a given Square within a Grid
     * (including Grid 0, the overall Grid, in the case of a Square being taken on the overall Grid)
     * and also checks to see if taking that Square resulted in a win for the given Grid
     */
    
    int i, j, winChecker;
    
    for (i=0; i<8; ++i)
    {
        winChecker=0;
        for (j=0; j<3; ++j)
        {
            if (winningMoves[whichGrid][i][j] == whichSquare) winningMoves[whichGrid][i][j] = currentPlayerValue;
            winChecker = winChecker + winningMoves[whichGrid][i][j];
        }
        if (winChecker == currentPlayerValue*3) return 1;	//  This move wins the grid; no need to keep checking/updating
    }
    return 0;
}

void drawWinningXorO(unsigned int x, unsigned int y, char XorO)
{
    
    /*
     * Draw a big X or O in a Grid when that Grid is won
     * 
     * For the splash screen X and O, see drawBigX or drawBigO)
     */

    int i, pauseTime=250, soundStage=1;
    
    if (noSpeedLimit) pauseTime=0;	// Insert a delay so the drawing speed is more aesthetically pleasing.
    
    for (i=0; i<5; ++i) { cclearxy(x,y+i,5); }
    POKE(50,63);  // Normal=255, Inverse=63, Flash=127
    if (XorO == 'X')
    {
        cputsxy(x,   y,   " "); waitForDuration(pauseTime);
        cputsxy(x+1, y+1, " "); waitForDuration(pauseTime);
        cputsxy(x+2, y+2, " "); waitForDuration(pauseTime);
        cputsxy(x+3, y+3, " "); waitForDuration(pauseTime);
        cputsxy(x+4, y+4, " "); waitForDuration(pauseTime);
        cputsxy(x+4, y,   " "); waitForDuration(pauseTime);
        cputsxy(x+3, y+1, " "); waitForDuration(pauseTime);
        cputsxy(x+1, y+3, " "); waitForDuration(pauseTime);
        cputsxy(x,   y+4, " ");
    }
    else
    {
        cputsxy(x+1, y,   " "); waitForDuration(pauseTime);
        cputsxy(x+2, y,   " "); waitForDuration(pauseTime);
        cputsxy(x+3, y,   " "); waitForDuration(pauseTime);
        cputsxy(x+4, y+1, " "); waitForDuration(pauseTime);
        cputsxy(x+4, y+2, " "); waitForDuration(pauseTime);
        cputsxy(x+4, y+3, " "); waitForDuration(pauseTime);
        cputsxy(x+3, y+4, " "); waitForDuration(pauseTime);
        cputsxy(x+2, y+4, " "); waitForDuration(pauseTime);
        cputsxy(x+1, y+4, " "); waitForDuration(pauseTime);
        cputsxy(x,   y+3, " "); waitForDuration(pauseTime);
        cputsxy(x,   y+2, " "); waitForDuration(pauseTime);
        cputsxy(x,   y+1, " ");
    }
    POKE(50,255);  // Normal=255, Inverse=63, Flash=127
}

void drawBigTie(unsigned int x, unsigned int y)
{
    // Write "tied" inside a Grid when that Grid ends in a tie
    
    int i, pauseTime=1000, soundStage=1;
    
    if (noSpeedLimit) pauseTime=0;	// Insert a waiting period so the words pop up with a more aesthetically pleasing timing.

    for (i=0; i<5; ++i) { cclearxy(x, y+i, 5); }
    POKE(50,63);  // Normal=255, Inverse=63, Flash=127
    playSong(2);
    cputsxy(x,   y,   "TIE"); waitForDuration(pauseTime);
    cputsxy(x+1, y+2, "TIE"); waitForDuration(pauseTime);
    cputsxy(x+2, y+4, "TIE");
    POKE(50,255);  // Normal=255, Inverse=63, Flash=127
}

void clearBigLetter(unsigned int x, unsigned int y)
{
    int i;
    for (i=0; i<5; ++i) { cclearxy(x, y+i, 9); }
    return;
}

void drawBigX(unsigned int x, unsigned int y)
{
    // This is for the splash screen, not a "winning" X (see: drawWinningXorO)
    
    POKE(50,63);  // Normal=255, Inverse=63, Flash=127
    cputsxy(x, y,  "   ");
    cputsxy(x+6, y,  "   ");
    cputsxy(x+1, y+1,  "   ");
    cputsxy(x+5, y+1,  "   ");
    cputsxy(x+2, y+2,  "     ");
    cputsxy(x+1, y+3,  "   ");
    cputsxy(x+5, y+3,  "   ");
    cputsxy(x, y+4,  "   ");
    cputsxy(x+6, y+4,  "   ");
    POKE(50,255);  // Normal=255, Inverse=63, Flash=127
}

void drawBigO(unsigned int x, unsigned int y)
{
    // This is for the splash screen, not a "winning" O (see: drawWinningXorO)
    
    POKE(50,63);  // Normal=255, Inverse=63, Flash=127
    cputsxy(x, y,    "         ");
    cputsxy(x, y+1  ,"         ");
    cputsxy(x, y+2,  "   ");
    cputsxy(x+6, y+2,"   ");
    cputsxy(x, y+3,  "         ");
    cputsxy(x, y+4,  "         ");
    POKE(50,255);  // Normal=255, Inverse=63, Flash=127
}

void drawBigT(unsigned int x, unsigned int y)
{
    POKE(50,63);  // Normal=255, Inverse=63, Flash=127
    cputsxy(x, y,    "         ");
    cputsxy(x, y+1,    "         ");
    cputsxy(x+2, y+2,    "     ");
    cputsxy(x+2, y+3,    "     ");
    cputsxy(x+2, y+4,    "     ");
    POKE(50,255);  // Normal=255, Inverse=63, Flash=127
}

void drawBigI(unsigned int x, unsigned int y)
{
    POKE(50,63);  // Normal=255, Inverse=63, Flash=127
    cputsxy(x, y,    "         ");
    cputsxy(x, y+1,   "         ");
    cputsxy(x+2, y+2,    "     ");
    cputsxy(x, y+3,   "         ");
    cputsxy(x, y+4,  "         ");
    POKE(50,255);  // Normal=255, Inverse=63, Flash=127
}

void drawBigC(unsigned int x, unsigned int y)
{
    POKE(50,63);  // Normal=255, Inverse=63, Flash=127
    cputsxy(x, y,    "         ");
    cputsxy(x, y+1  ,"         ");
    cputsxy(x, y+2,  "     ");
    cputsxy(x, y+3,  "         ");
    cputsxy(x, y+4,  "         ");
    POKE(50,255);  // Normal=255, Inverse=63, Flash=127
}

void drawBigA(unsigned int x, unsigned int y)
{
    POKE(50,63);  // Normal=255, Inverse=63, Flash=127
    cputsxy(x+1, y,   "       ");
    cputsxy(x,y+1,"   "); cputsxy(x+6,y+1,"   ");
    cputsxy(x, y+2,   "         ");
    cputsxy(x,y+3,"   "); cputsxy(x+6,y+3,"   ");
    cputsxy(x,y+4,"   "); cputsxy(x+6,y+4,"   ");
    POKE(50,255);  // Normal=255, Inverse=63, Flash=127
}

void drawBigP(unsigned int x, unsigned int y)
{
    POKE(50,63);  // Normal=255, Inverse=63, Flash=127
    cputsxy(x, y,  "         ");
    cputsxy(x,y+1,"    "); cputsxy(x+6,y+1,"   ");
    cputsxy(x, y+2, "         ");
    cputsxy(x,y+3,"    ");
    cputsxy(x,y+4,"    ");
    POKE(50,255);  // Normal=255, Inverse=63, Flash=127
}

void drawBigR(unsigned int x, unsigned int y)
{
    POKE(50,63);  // Normal=255, Inverse=63, Flash=127
    cputsxy(x, y,  "         ");
    cputsxy(x,y+1,"    "); cputsxy(x+6,y+1,"   ");
    cputsxy(x, y+2, "         ");
    cputsxy(x,y+3,"    "); cputsxy(x+5,y+3,"   ");
    cputsxy(x,y+4,"    "); cputsxy(x+6,y+4,"   ");
    POKE(50,255);  // Normal=255, Inverse=63, Flash=127
}

/*
 * Did you notice that all those DrawBig_ routines are essentially THE SAME THING OVER AND OVER with slightly different spaces?
 * Yes, I could/should have made those all a single routine, but I'm tired and distracted. So copy-paste-copy-paste is what you get.
 */

void drawSplashScreen()
{
    // The pauses are timing delays just to make the drawing speed more (you guessed it) aesthetically pleasing

    char c;
    unsigned int shortPause=500, mediumPause=2000, longPause=5000;
    unsigned int i = 0, maxInt = INT_MAX;
    
    if (noSpeedLimit)
    {
        shortPause=0;
        mediumPause=0;
        longPause=0;
    }
    
    clrscr();
    
    /*
     * If you thought I was lazily copying-and-pasting code over and over instead of writing efficient routines so far, 
     * just wait until you get a load of this:
     */
    
    drawBigX(15,9); waitForDuration(mediumPause);
    drawBigO(2,1); waitForDuration(mediumPause);
    drawBigX(28,17); waitForDuration(mediumPause);
    drawBigO(2,17); waitForDuration(mediumPause);
    drawBigX(2,9); waitForDuration(mediumPause);
    drawBigO(28,9); waitForDuration(mediumPause);
    drawBigX(15,17); waitForDuration(mediumPause);
    drawBigO(15,1); waitForDuration(mediumPause);
    drawBigX(28,1);  waitForDuration(longPause);
    
    clearBigLetter(2,1); drawBigT(2,1); waitForDuration(mediumPause);
    clearBigLetter(15,1); drawBigI(15,1); waitForDuration(mediumPause);
    clearBigLetter(28,1); drawBigC(28,1); waitForDuration(mediumPause);
    clearBigLetter(2,9); drawBigT(2,9); waitForDuration(mediumPause);
    clearBigLetter(15,9); drawBigA(15,9); waitForDuration(mediumPause);
    clearBigLetter(28,9); drawBigC(28,9); waitForDuration(mediumPause);
    clearBigLetter(2,17); drawBigP(2,17); waitForDuration(mediumPause);
    clearBigLetter(15,17); drawBigR(15,17); waitForDuration(mediumPause);
    clearBigLetter(28,17); drawBigO(28,17);
    
    playSong(6);
    
    centre(20,23,"< >"); waitForDuration(shortPause);
    centre(20,23,"<< >>"); waitForDuration(shortPause);
    centre(20,23,"<<< >>>"); waitForDuration(shortPause);
    centre(20,23,"<<< R >>>"); waitForDuration(shortPause);
    centre(20,23,"<<< URN >>>"); waitForDuration(shortPause);
    centre(20,23,"<<< TURN  >>>"); waitForDuration(shortPause);
    centre(20,23,"<<< ETURN T >>>"); waitForDuration(shortPause);
    centre(20,23,"<<< RETURN TO >>>"); waitForDuration(shortPause);
    centre(20,23,"<<<  RETURN TO  >>>"); waitForDuration(shortPause);
    centre(20,23,"<<< S RETURN TO B >>>"); waitForDuration(shortPause);
    centre(20,23,"<<< SS RETURN TO BE >>>"); waitForDuration(shortPause);
    centre(20,23,"<<< ESS RETURN TO BEG >>>"); waitForDuration(shortPause);
    centre(20,23,"<<< RESS RETURN TO BEGI >>>"); waitForDuration(shortPause);
    centre(20,23,"<<< PRESS RETURN TO BEGIN >>>"); waitForDuration(shortPause);
    centre(20,23,"<<  PRESS RETURN TO BEGIN  >>"); waitForDuration(shortPause);
    centre(20,23,"<   PRESS RETURN TO BEGIN   >"); waitForDuration(shortPause);
    centre(20,23,"    PRESS RETURN TO BEGIN    ");
    
    /*
     * I could use the waitForReturn() routine here, but instead I'll implement the same thing locally.
     * Why? So I can increment a counter while it's waiting, and I want to use that counter to seed the rg.
     *
     * The reason for THAT is the _randomize function in cc65 is a BIG LIE. Completely non-random.
     * It's not even random-ish. And since I'm too lazy/dumb to figure out a bit of memory I can
     * peek at to get a sufficiently entropy-y number, I'll just use the pause duration as the seed.
     *
     * There must be a source of entropy somewhere in the Apple II's memory, though. I wish I knew where it was.
     */
    
    while (1) //    flush out any existing keys
    {
        if (i == INT_MAX) i = 0;
        ++i;
        if (kbhit())
        {
            c = cgetc();
        }
        else
        {
            break;
        }
    }
    while(1) // Now that key buffer is empty, wait for a return...
    {
        if (i == INT_MAX) i = 0;
        ++i;
        if (kbhit())
        {
            c = cgetc();
            if (c == '\r')
            {
                break;
            }
        }
    }
    srand(i);
}

void setupComputerPlayer(unsigned int whichPlayer)
{
    unsigned int foo;   // Ah, foo. Glorious foo. Lazy, sloppy, mystery-meat, glorious foo.
    
    char *names[12] =
    {
        {"BIG BLUE"},
        {"BANANA, JR."},
        {"HAL 9000"},
        {"DEEP THOUGHT"},
        {"WOPR"},
        {"SKYNET"},
        {"MAX HEADROOM"},
        {"DR. THEOPOLIS"},
        {"HOLLY"},
        {"GLADOS"},
        {"NEUROMANCER"},
        {"COLOSSUS"}
    };
    
    unsigned int personalities[12][6] =
    {
        /* 
         * Sets number of points to be awarded for the following:
         *      Value of sending opponent to another Grid rather than staying here, all other things being equal
         *      Value of a taking a second Square in a local triple (e.g. turning X-- into XX-)
         *      Value of a making a pre-emptive block in a local triple (e.g. turning O-- into OX-)
         *      Value of a local win move
         *      Value of a local block move
         *      Value of winning the whole game (you'd think this would always be a big number, but nope).
         */
        {1,15,10,60,50,1000},   //  BIG BLUE        -- balanced "standard" setup
        {0,0,0,60,20,1000},     //  BANANA, JR.     -- short sighted
        {1,5,1,100,10,1000},    //  HAL 9000        -- starts calm, becomes obsessed
        {5,10,20,5,50,1000},    //  DEEP THOUGHT    -- won't get to the point
        {0,5,25,20,50,1000},    //  WOPR            -- goes for the tie
        {1,25,0,100,0,1000},    //  SKYNET          -- all the aggression all the time
        {10,10,10,20,20,1000},  //  MAX HEADROOM    -- erratic
        {0,5,5,3,2,0},          //  DR. THEOPOLIS   -- easily distracted
        {100,20,10,0,10,10},    //  HOLLY           -- extra loopy
        {1,15,10,40,60,20},      //  GLADOS          -- wants to drag out your suffering
        {1,5,25,30,25,1000},    //  NEUROMANCER     -- oblique attacks
        {1,10,0,100,20,1000}    //  COLOSSUS        -- starts friendly, turns aggressive
    };
    
    unsigned int randomNum = (rand() % 12);

    strcpy(playerName[whichPlayer], names[randomNum]);

    // Double check that we don't end up with the same computer playing itself (hmm, or would that be okay?)

    if ( (whichPlayer) && (playerIsComputer[0]) && (playerIsComputer[1]) )
    {
        while (!strncmp(playerName[0],playerName[1],14))
        {
            randomNum = (rand() % 12);
            strcpy(playerName[whichPlayer], names[randomNum]);
        }
    }
    
    for (foo=0; foo<6; ++foo)
    {
        playerPersonality[whichPlayer][foo] = personalities[whichPlayer][foo];
    }
}

void setupNewGame()
{
    unsigned int i,foo;
    char c;
    
    playerScore[0]=0;
    playerScore[1]=0;
    activeGrid = 0;
    
    for (i=0; i<2; ++i)
    {
        clrscr();
        drawWinningXorO(18, 5, playerLetter[i]);
        if (!noSpeedLimit) playSong(i); // So: if "not no speed limit"??? Look at me, the double negative guy.
        clearKeyBuffer();
        cputsxy(7, 12, "NAME OF PLAYER:");
        centre(20, 17, "(LEAVE BLANK FOR COMPUTER OPPONENT)");
        
        if (autoLoop)
        {
            foo = 0;
        }
        else
        {
            foo = getText(23, 12, playerName[i], 14);
        }
        
        if (foo)
        {
            playerIsComputer[i] = 0;
        }
        else
        {
            playerIsComputer[i] = 3;
            setupComputerPlayer(i);
        }
    }
    
    if (autoLoop)
    {
        noSounds=1; // 1=run silent, run deep
    }
    else
    {
        clrscr();
        centre(18,12,"SOUND ON? ");
        POKE(50,127);  // Normal=255, Inverse=63, Flash=127
        cputc('Y');
        POKE(50,255);  // Normal=255, Inverse=63, Flash=127
        cputc('/');
        POKE(50,127);  // Normal=255, Inverse=63, Flash=127
        cputc('N');
        POKE(50,255);  // Normal=255, Inverse=63, Flash=127
        
        clearKeyBuffer();
        while (1)
        {
            if (kbhit())
            {
                c = toupper(cgetc());
                if (c == 'Y') { noSounds=0; break; }
                if (c == 'N') { noSounds=1; break; }
                
                /*
                 * Note: I only just now realized how ass-backwards it is that I am using "noSounds=1" rather than "sound=0".
                 *
                 * KansasFest, you have ruined me.
                 */
            }
        }
    }
    
    clrscr();
}

void drawValidMoveGuide()
{
    /*
     * Clear off the former guide numbers/letters around the edge of the board.
     *
     * A smarter person than me (hi Quinn) would just use some kind of function to set the active grid, which used the current 
     * playerGrid and activeGrid to only erase the necessary letters. But this is KFest, and so down-and-dirty is WHAT YOU GET.
     *
     * Also, more same-lines-copied-over-and-over-instead-of-coding-a-loop. I've come to think of that as "style".
     */
    
    cputsxy(0, 0,  "                       ");
    cputsxy(0, 2,  " ");
    cputsxy(0, 4,  " ");
    cputsxy(0, 6,  " ");
    cputsxy(0, 10,  " ");
    cputsxy(0, 12,  " ");
    cputsxy(0, 14,  " ");
    cputsxy(0, 18,  " ");
    cputsxy(0, 20,  " ");
    cputsxy(0, 22,  " ");
    
    switch(activeGrid)
    {
        case 1:
            cputsxy(2, 0,  "1 2 3");
            cputsxy(0, 2,  "A");
            cputsxy(0, 4,  "B");
            cputsxy(0, 6,  "C");
            break;
        case 2:
            cputsxy(10, 0,  "4 5 6");
            cputsxy(0, 2,  "A");
            cputsxy(0, 4,  "B");
            cputsxy(0, 6,  "C");
            break;
        case 3:
            cputsxy(18, 0,  "7 8 9");
            cputsxy(0, 2,  "A");
            cputsxy(0, 4,  "B");
            cputsxy(0, 6,  "C");
            break;
        case 4:
            cputsxy(2, 0,  "1 2 3");
            cputsxy(0, 10,  "D");
            cputsxy(0, 12,  "E");
            cputsxy(0, 14,  "F");
            break;
        case 5:
            cputsxy(10, 0,  "4 5 6");
            cputsxy(0, 10,  "D");
            cputsxy(0, 12,  "E");
            cputsxy(0, 14,  "F");
            break;
        case 6:
            cputsxy(18, 0,  "7 8 9");
            cputsxy(0, 10,  "D");
            cputsxy(0, 12,  "E");
            cputsxy(0, 14,  "F");
            break;
        case 7:
            cputsxy(2, 0,  "1 2 3");
            cputsxy(0, 18,  "G");
            cputsxy(0, 20,  "H");
            cputsxy(0, 22,  "I");
            break;
        case 8:
            cputsxy(10, 0,  "4 5 6");
            cputsxy(0, 18,  "G");
            cputsxy(0, 20,  "H");
            cputsxy(0, 22,  "I");
            break;
        case 9:
            cputsxy(18, 0,  "7 8 9");
            cputsxy(0, 18,  "G");
            cputsxy(0, 20,  "H");
            cputsxy(0, 22,  "I");
            break;
        case 0:
        default:
            cputsxy(0, 0,  "  1 2 3   4 5 6   7 8 9");
            cputsxy(0, 2,  "A");
            cputsxy(0, 4,  "B");
            cputsxy(0, 6,  "C");
            cputsxy(0, 10,  "D");
            cputsxy(0, 12,  "E");
            cputsxy(0, 14,  "F");
            cputsxy(0, 18,  "G");
            cputsxy(0, 20,  "H");
            cputsxy(0, 22,  "I");
            break;
    }
    
    return;
}

void displayScore()
{
    char str[14], buffer[6];
    
    itoa(playerScore[0],buffer,10);
    strcat(str, buffer);
    strcat(str, " TO ");
    itoa(playerScore[1],buffer,10);
    strcat(str, buffer);
    
    centre(32,20,"CURRENT SCORE:");
    centre(32,21,str);
    cputsxy(26,22,"REMATCH? ");
    POKE(50,127);  // Normal=255, Inverse=63, Flash=127
    cputc('Y');
    POKE(50,255);  // Normal=255, Inverse=63, Flash=127
    cputc('/');
    POKE(50,127);  // Normal=255, Inverse=63, Flash=127
    cputc('N');
    POKE(50,255);  // Normal=255, Inverse=63, Flash=127

}

unsigned int announceWinner()
{
    unsigned int pauseTime=250, yPos, maxAutoLoop=1000;   // maxAutoLoop is just a bounds limit, so the loop doesn't get out of hand.
    char c;
    
    yPos = 6 + (10*(currentPlayer));
    
    if (noSpeedLimit) pauseTime=0;	// The pause just slows down the "drawing" to make it more aesthetically pleasing
    
    playSong(3+currentPlayer);
    centre(32,yPos,"              "); waitForDuration(pauseTime);
    centre(32,yPos,">            <"); waitForDuration(pauseTime);
    centre(32,yPos,">>          <<"); waitForDuration(pauseTime);
    centre(32,yPos,">>>        <<<"); waitForDuration(pauseTime);
    centre(32,yPos,">>>>      <<<<"); waitForDuration(pauseTime);
    centre(32,yPos," >>>>    <<<< "); waitForDuration(pauseTime);
    centre(32,yPos,"  >>>>  <<<<  "); waitForDuration(pauseTime);
    centre(32,yPos,"   >>>><<<<   "); waitForDuration(pauseTime);
    centre(32,yPos,"    >><><<    "); waitForDuration(pauseTime);
    centre(32,yPos,"     <<>>     "); waitForDuration(pauseTime);
    centre(32,yPos,"    <<<>>>    "); waitForDuration(pauseTime);
    centre(32,yPos,"   <<<<>>>>   "); waitForDuration(pauseTime);
    centre(32,yPos,"  <<<<  >>>>  "); waitForDuration(pauseTime);
    centre(32,yPos," <<<<    >>>> "); waitForDuration(pauseTime);
    centre(32,yPos,"<<<<      >>>>"); waitForDuration(pauseTime);
    centre(32,yPos,"<<<        >>>"); waitForDuration(pauseTime);
    centre(32,yPos,"<<          >>"); waitForDuration(pauseTime);
    centre(32,yPos,"<            >"); waitForDuration(pauseTime);
    centre(32,yPos,"              "); waitForDuration(pauseTime);
    centre(32,yPos,"N            N"); waitForDuration(pauseTime);
    centre(32,yPos,"IN          NE"); waitForDuration(pauseTime);
    centre(32,yPos,"WIN        NER"); waitForDuration(pauseTime);
    centre(32,yPos," WIN      NER "); waitForDuration(pauseTime);
    centre(32,yPos,"  WIN    NER  "); waitForDuration(pauseTime);
    centre(32,yPos,"   WIN  NER   "); waitForDuration(pauseTime);
    centre(32,yPos,"    WINNER    "); waitForDuration(pauseTime);
    
    if (!currentPlayer)
    {
        ++playerScore[0];
        if (playerScore[0]>maxAutoLoop)
        {
            playerScore[0]==maxAutoLoop;
            autoLoop=0;
        }
    }
    else
    {
        ++playerScore[1];
        if (playerScore[1]>maxAutoLoop)
        {
            playerScore[1]==maxAutoLoop;
            autoLoop=0;
        }
    }
    
    displayScore();
    
    if (!noSpeedLimit) pauseTime=1000;  // The pause just slows down the scrolling "stars" to make them more attractive.
                                        // I wrote "attractive" above because, frankly, I'm sick of typing "aesthetically pleasing".
    clearKeyBuffer();
    while (1)
    {
        // TO DO: Add some sort of end state condition, and ability to restart/quit gracefully. Yeah, I actually didn't do that yet. Crazy, eh?

        centre(32,yPos-1,"*++*++*+");
        centre(32,yPos  ,"+WINNER+");
        centre(32,yPos+1,"+*++*++*");
        waitForDuration(pauseTime);
        centre(32,yPos-1,"+*++*++*");
        centre(32,yPos  ,"+WINNER+");
        centre(32,yPos+1,"*++*++*+");
        waitForDuration(pauseTime);
        centre(32,yPos-1,"++*++*++");
        centre(32,yPos  ,"*WINNER*");
        centre(32,yPos+1,"++*++*++");
        waitForDuration(pauseTime);
        if (autoLoop) return 1;		// If autoLoop is on, then (no surprise here) automatically play again without asking.
        if (kbhit())
        {
            c = toupper(cgetc());
            if (c == 'Y') { return 1; } // Yes, play again
            if (c == 'N') { return 0; } // No, don't play again
                                        // Any other key, just keep looping and wait for Y or N
        }
    }
}

unsigned int announceTie()
{
    unsigned int pauseTime=250, yPos;
    char c;
    
    yPos = 6;
    if (noSpeedLimit) pauseTime=0;	// Insert that same darn comment again about the pause making the "drawing" more aesthetically pleasing.
                                    // Sheesh, I should've just called the darn variable "makeAestheticallyPleasing"
    playSong(5);
    centre(32,yPos,"              "); centre(32,yPos+10,"              "); waitForDuration(pauseTime);
    centre(32,yPos,">            <"); centre(32,yPos+10,">            <"); waitForDuration(pauseTime);
    centre(32,yPos,">>          <<"); centre(32,yPos+10,">>          <<"); waitForDuration(pauseTime);
    centre(32,yPos,">>>        <<<"); centre(32,yPos+10,">>>        <<<"); waitForDuration(pauseTime);
    centre(32,yPos,">>>>      <<<<"); centre(32,yPos+10,">>>>      <<<<"); waitForDuration(pauseTime);
    centre(32,yPos," >>>>    <<<< "); centre(32,yPos+10," >>>>    <<<< "); waitForDuration(pauseTime);
    centre(32,yPos,"  >>>>  <<<<  "); centre(32,yPos+10,"  >>>>  <<<<  "); waitForDuration(pauseTime);
    centre(32,yPos,"   >>>><<<<   "); centre(32,yPos+10,"   >>>><<<<   "); waitForDuration(pauseTime);
    centre(32,yPos,"    >><><<    "); centre(32,yPos+10,"    >><><<    "); waitForDuration(pauseTime);
    centre(32,yPos,"     <<>>     "); centre(32,yPos+10,"     <<>>     "); waitForDuration(pauseTime);
    centre(32,yPos,"    <<<>>>    "); centre(32,yPos+10,"    <<<>>>    "); waitForDuration(pauseTime);
    centre(32,yPos,"   <<<<>>>>   "); centre(32,yPos+10,"   <<<<>>>>   "); waitForDuration(pauseTime);
    centre(32,yPos,"  <<<<  >>>>  "); centre(32,yPos+10,"  <<<<  >>>>  "); waitForDuration(pauseTime);
    centre(32,yPos," <<<<    >>>> "); centre(32,yPos+10," <<<<    >>>> "); waitForDuration(pauseTime);
    centre(32,yPos,"<<<<      >>>>"); centre(32,yPos+10,"<<<<      >>>>"); waitForDuration(pauseTime);
    centre(32,yPos,"<<<        >>>"); centre(32,yPos+10,"<<<        >>>"); waitForDuration(pauseTime);
    centre(32,yPos,"<<          >>"); centre(32,yPos+10,"<<          >>"); waitForDuration(pauseTime);
    centre(32,yPos,"<            >"); centre(32,yPos+10,"<            >"); waitForDuration(pauseTime);
    centre(32,yPos,"              "); centre(32,yPos+10,"              "); waitForDuration(pauseTime);
    centre(32,yPos,"I            E"); centre(32,yPos+10,"I            E"); waitForDuration(pauseTime);
    centre(32,yPos,"TI          ED"); centre(32,yPos+10,"TI          ED"); waitForDuration(pauseTime);
    centre(32,yPos," TI        ED "); centre(32,yPos+10," TI        ED "); waitForDuration(pauseTime);
    centre(32,yPos,"  TI      ED  "); centre(32,yPos+10,"  TI      ED  "); waitForDuration(pauseTime);
    centre(32,yPos,"   TI    ED   "); centre(32,yPos+10,"   TI    ED   "); waitForDuration(pauseTime);
    centre(32,yPos,"    TI  ED    "); centre(32,yPos+10,"    TI  ED    "); waitForDuration(pauseTime);
    centre(32,yPos,"     TIED     "); centre(32,yPos+10,"     TIED     "); waitForDuration(pauseTime);
    
    displayScore();
    
    if (!noSpeedLimit) pauseTime=1000;  // Slow stars are pretty stars. Preeeeeetty.
    clearKeyBuffer();
    while (1)
    {
        // To Do: Add some sort of end state condition, and ability to restart/quit gracefully
        centre(32,yPos-1,"*++*++*+"); centre(32,yPos +9,"*++*++*+");
        centre(32,yPos  ,"+ TIED +"); centre(32,yPos+10,"+ TIED +");
        centre(32,yPos+1,"+*++*++*"); centre(32,yPos+11,"+*++*++*");
        waitForDuration(pauseTime);
        centre(32,yPos-1,"+*++*++*"); centre(32,yPos +9,"+*++*++*");
        centre(32,yPos  ,"+ TIED +"); centre(32,yPos+10,"+ TIED +");
        centre(32,yPos+1,"*++*++*+"); centre(32,yPos+11,"*++*++*+");
        waitForDuration(pauseTime);
        centre(32,yPos-1,"++*++*++"); centre(32,yPos +9,"++*++*++");
        centre(32,yPos  ,"* TIED *"); centre(32,yPos+10,"* TIED *");
        centre(32,yPos+1,"++*++*++"); centre(32,yPos+11,"++*++*++");
        waitForDuration(pauseTime);
        if (autoLoop) return 1;		// Guess what autoLoop means. Go on, guess.
        if (kbhit())
        {
            c = toupper(cgetc());
            if (c == 'Y') { return 1; } // Yes, play again
            if (c == 'N') { return 0; } // No, don't play again
                                        // Any other key, just keep looping and wait for Y or N
        }
    }
}

void drawNewGameBoard()
{
    /*
     * Yes, just like drawValidMoveGuide() above, this routine is also basically just a big dumb list of strings.
     * Don't look at me! I'm a monster!
     */
    unsigned int i=0;
    clrscr();
    
    cputsxy(0, 0,  "  1 2 3   4 5 6   7 8 9");
    cputsxy(0, 2,  "A  ! !  *  ! !  *  ! !  ");
    cputsxy(0, 3,  "  ----- * ----- * ----- ");
    cputsxy(0, 4,  "B  ! !  *  ! !  *  ! !  ");
    cputsxy(0, 5,  "  ----- * ----- * ----- ");
    cputsxy(0, 6,  "C  ! !  *  ! !  *  ! !  ");
    
    cputsxy(0, 10,  "D  ! !  *  ! !  *  ! !  ");
    cputsxy(0, 11,  "  ----- * ----- * ----- ");
    cputsxy(0, 12,  "E  ! !  *  ! !  *  ! !  ");
    cputsxy(0, 13,  "  ----- * ----- * ----- ");
    cputsxy(0, 14,  "F  ! !  *  ! !  *  ! !  ");
    
    cputsxy(0, 18,  "G  ! !  *  ! !  *  ! !  ");
    cputsxy(0, 19,  "  ----- * ----- * ----- ");
    cputsxy(0, 20,  "H  ! !  *  ! !  *  ! !  ");
    cputsxy(0, 21,  "  ----- * ----- * ----- ");
    cputsxy(0, 22,  "I  ! !  *  ! !  *  ! ! ");
    
    POKE(50,63);  // Normal=255, Inverse=63, Flash=127
    for (i=2; i<23; ++i)
    {
        cputsxy(8, i,  " ");
        cputsxy(16, i,  " ");
    }
    cputsxy(2, 8,  "                     ");
    cputsxy(2, 16, "                     ");

    centre(32, 2, "              ");
    centre(32, 2, playerName[0]);
    centre(32, 12, "              ");
    centre(32, 12, playerName[1]);
    
    POKE(50,255);  // Normal=255, Inverse=63, Flash=127
    
    return;
}

unsigned int doMove()
{
    /* Gets and performs a move by either a human or computer player.
     *
     * At the end, it checks for whether this move resulted in a win or tie for the overall game
     * and returns an int accordingly:
     *      0 = Move did not result in either an overall win or an overall tie
     *      1 = Move resulted in an overall win
     *      2 = Move resulted in overall tied game
     */
    
    unsigned int gridCoordX, gridCoodY, wonGrid, wonGame;
    unsigned int i, isTied;
    unsigned int validMove = 0;
    
    if (!playerIsComputer[currentPlayer])
    {
        feedback("");	// Erase feedback line
        while (!validMove)
        {
            getHumanPlayerMove();	/* This sets playerMove as 2-char string in format "A#", and more usefully, sets playerMoveGrid and
                                     * playerMoveSquare to the corresponding int for the grid and square of that move
                                     *
                                     * Examples:
                                     *      if playerMove is "A1" then playerMoveGrid=1, playerMoveSquare=1
                                     *      if playerMove is "G5" then playerMoveGrid=8, playerMoveSquare=2
                                     */
            
            validMove = checkMoveValidity();
        }
    }
    else  // current player is a computer opponent
    {
        getComputerPlayerMove();
    }
    
    // Record the move by updating gridStatus, removing this square from future play
    gridStatus[playerMoveGrid][playerMoveSquare]=currentPlayerValue;
    
    // Print an 'X' or 'O' in the square that corresponds to the player's move
    gridCoordX = gridLocations[playerMoveGrid-1][0];
    gridCoodY = gridLocations[playerMoveGrid-1][1];
    drawMove(gridCoordX,gridCoodY,currentPlayerLetter);
    
    // Update the triples within winningMoves, and see if this move wins a grid
    wonGrid = checkForWin(playerMoveGrid,playerMoveSquare);
    if (!wonGrid)
    {
        /* 
         * Although this move did not win the grid, it may have tied it. Check for a tie in this grid,
         * and if so then mark the grid as no longer available on overall grid (0)
         */
        isTied=1;
        for (i=1; i<10; ++i)
        {
            if (!gridStatus[playerMoveGrid][i])
            {
                isTied=0;
                break;
            }
        }
        if (isTied)
        {
            drawBigTie(gridCoordX, gridCoodY);                          // Draw "tied" all over this grid
            gridStatus[playerMoveGrid][0] = playerTieValue;				// Mark this grid as tied
            gridStatus[0][playerMoveGrid] = playerTieValue;				// Mark this grid as tied
        }
    }
    else	// This WAS a move that won a grid ... fwew! FINALLY OUR LONG NATIONAL TIC-TAC-TOE NIGHTMARE IS OVER.
    {
        drawWinningXorO(gridCoordX, gridCoodY, currentPlayerLetter);	//	Draw the X or O over this grid
        playSong(currentPlayer);
        gridStatus[playerMoveGrid][0] = currentPlayerValue;				//	Mark this grid as won
        gridStatus[0][playerMoveGrid] = currentPlayerValue;				//	Mark this grid as won
        
        // Since player won this grid, check to see if that wins the whole game too
        wonGame = checkForWin(0,playerMoveGrid);
        if (wonGame)
        {
            return 1;   // Move resulted in an overall win
        }
    }
    
    // As a last check, see if this latest move resulted in an overall tied game (e.g. no available grids left to play)
    isTied=1;
    for (i=1; i<10; ++i)
    {
        if (!gridStatus[i][0])
        {
            isTied=0;
            break;
        }
    }
    if (isTied)
    {
        return 2;	// Move resulted in overall tied game
    }
    
    // Set the new activeGrid
    if (!gridStatus[playerMoveSquare][0])
    { activeGrid = playerMoveSquare; }	// Set the active grid to match the previous move's square
    else
    { activeGrid = 0; }					// Grid matching previous move's square was already won/tied, so whole grid is fair game
    
    return 0;	// Move did not result in either an overall win or an overall tie
}

void resetGrid()
{
    unsigned int i, j;

    for (i=0; i<10; ++i)
    {
        winningMoves[i][0][0]=1; winningMoves[i][0][1]=3; winningMoves[i][0][2]=2;
        winningMoves[i][1][0]=5; winningMoves[i][1][1]=4; winningMoves[i][1][2]=6;
        winningMoves[i][2][0]=7; winningMoves[i][2][1]=9; winningMoves[i][2][2]=8;
        winningMoves[i][3][0]=1; winningMoves[i][3][1]=7; winningMoves[i][3][2]=4;
        winningMoves[i][4][0]=5; winningMoves[i][4][1]=2; winningMoves[i][4][2]=8;
        winningMoves[i][5][0]=3; winningMoves[i][5][1]=9; winningMoves[i][5][2]=6;
        winningMoves[i][6][0]=5; winningMoves[i][6][1]=1; winningMoves[i][6][2]=9;
        winningMoves[i][7][0]=5; winningMoves[i][7][1]=3; winningMoves[i][7][2]=7;
    }
    
    for (i=0; i<10; ++i)
    {
        for (j=0; j<10; ++j)
        {
            gridStatus[i][j]=0;
        }
    }
    activeGrid=0;
    
    return;
}

void main ()
{
    unsigned int rematch=0;
    
    beepSetup();
    POKE(0xC051,0);  // text
    POKE(0xC054,0);  // page 1
    clrscr();
    drawSplashScreen();    
    
    /*
     * MAIN GAME LOOP
     */
    
    while (1)
    {
        if (!rematch) { setupNewGame(); }
        drawNewGameBoard();
        resetGrid();
        
        while (1)
        {
            if (!currentPlayer)
            {
                currentPlayerValue = playerValue[0];
                currentPlayerLetter = playerLetter[0];
                opponentPlayerValue = playerValue[1];
            }
            else
            {
                currentPlayerValue = playerValue[1];
                currentPlayerLetter = playerLetter[1];
                opponentPlayerValue = playerValue[0];
            }
            
            gameStatus = doMove();
            
            if (gameStatus==1)	// Move resulted in overall win
            {
                rematch = announceWinner();
                break;
            }
            
            if (gameStatus==2)	// Move resulted in overall tie
            {
                rematch = announceTie();
                break;
            }
            
            currentPlayer = !currentPlayer;
            drawValidMoveGuide();
            
        }
        
        // At this point, rematch has been set to 0 (start fresh with new players) or 1 (rematch with same players, keep score)
        
    } // End of overall main game loop
    
}

/* To do & ideas:
 *
 * If a grid ends in a tie, maybe it should have an option to empty that grid and free it for play in current game?
 *          Did a test of this but it doesn't change outcome -- usually happens near end of game, and players then
 *               just "attack" the emptied grid like a standard tic-tac-toe game and get another tie
 *			Perhaps punish/reward player who gets the tie?
 *               e.g. leave 1 random move from othe player still in grid as a "head start"?
 *                    or other player gets first move in that grid?
 *			Possible fix for repeated ties:
 *               Perhaps repeated ties lead to one "big" X or O being removed/reset?
 *               But would it be a random one? One from the last/first/second-last play in tied grid?
 *          Not sure any of this would actually improve gameplay or make it more fun
 *
 * For rematch, should losing player go first?
 *          That might be better for competition play  e.g. easier "best of 3" competition
 *          Maybe make that the default for PvP play, but a per-match choice for PvC? (What about CvC?)
 *
 * Differentiate computer skill levels more?
 *          Should we let player select skill level for opponents?
 *          At the very least, player should be able to select opponent(s)
 */
